linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Tom Zanussi <zanussi@kernel.org>
To: rostedt@goodmis.org
Cc: tglx@linutronix.de, mhiramat@kernel.org, namhyung@kernel.org,
	vedang.patel@intel.com, bigeasy@linutronix.de,
	joel@joelfernandes.org, mathieu.desnoyers@efficios.com,
	julia@ni.com, linux-kernel@vger.kernel.org,
	linux-rt-users@vger.kernel.org
Subject: [PATCH v6 10/15] tracing: Add hist trigger snapshot() action test case
Date: Thu, 11 Oct 2018 16:02:07 -0500	[thread overview]
Message-ID: <75db4ded21471580e5ad8d57c74fd9c8923cd90a.1539288364.git.tom.zanussi@linux.intel.com> (raw)
In-Reply-To: <cover.1539288364.git.tom.zanussi@linux.intel.com>
In-Reply-To: <cover.1539288364.git.tom.zanussi@linux.intel.com>

From: Tom Zanussi <tom.zanussi@linux.intel.com>

Add a test case verifying the basic functionality of the
hist:snapshot() action.

Signed-off-by: Tom Zanussi <tom.zanussi@linux.intel.com>
---
 .../inter-event/trigger-snapshot-action-hist.tc    | 55 ++++++++++++++++++++++
 1 file changed, 55 insertions(+)
 create mode 100644 tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc

diff --git a/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc
new file mode 100644
index 000000000000..f427be989296
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-snapshot-action-hist.tc
@@ -0,0 +1,55 @@
+#!/bin/sh
+# description: event trigger - test inter-event histogram trigger snapshot action
+
+do_reset() {
+    reset_trigger
+    echo > set_event
+    echo 0 > snapshot
+    clear_trace
+}
+
+fail() { #msg
+    do_reset
+    echo $1
+    exit_fail
+}
+
+if [ ! -f set_event ]; then
+    echo "event tracing is not supported"
+    exit_unsupported
+fi
+
+if [ ! -f snapshot ]; then
+    echo "snapshot is not supported"
+    exit_unsupported
+fi
+
+grep "onchange(var)" README > /dev/null || exit_unsupported # version issue
+
+grep "snapshot()" README > /dev/null || exit_unsupported # version issue
+
+reset_tracer
+do_reset
+
+echo "Test snapshot action"
+
+echo 1 > /sys/kernel/debug/tracing/events/sched/enable
+
+echo 'hist:keys=comm:newprio=prio:onchange($newprio).save(comm,prio):onchange($newprio).snapshot() if comm=="ping"' >> /sys/kernel/debug/tracing/events/sched/sched_waking/trigger
+
+ping localhost -c 3
+nice -n 1 ping localhost -c 3
+
+echo 0 > /sys/kernel/debug/tracing/events/sched/enable
+
+if ! grep -q "changed:" events/sched/sched_waking/hist; then
+    fail "Failed to create onchange action inter-event histogram"
+fi
+
+if ! grep -q "comm=ping" snapshot; then
+    fail "Failed to create snapshot action inter-event histogram"
+fi
+
+do_reset
+
+exit 0
-- 
2.14.1


  parent reply	other threads:[~2018-10-11 21:02 UTC|newest]

Thread overview: 22+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-10-11 21:01 [PATCH v6 00/15] tracing: Hist trigger snapshot and onchange additions Tom Zanussi
2018-10-11 21:01 ` [PATCH v6 01/15] tracing: Refactor hist trigger action code Tom Zanussi
2018-10-23  5:09   ` Masami Hiramatsu
2018-10-23 21:18     ` Tom Zanussi
2018-10-11 21:01 ` [PATCH v6 02/15] tracing: Make hist trigger Documentation better reflect actions/handlers Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 03/15] tracing: Add hist trigger handler.action documentation to README Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 04/15] tracing: Split up onmatch action data Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 05/15] tracing: Generalize hist trigger onmax and save action Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 06/15] tracing: Add conditional snapshot Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 07/15] tracing: Move hist trigger key printing into a separate function Tom Zanussi
2018-10-23 14:37   ` Masami Hiramatsu
2018-10-23 21:24     ` Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 08/15] tracing: Add hist trigger snapshot() action Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 09/15] tracing: Add hist trigger snapshot() action Documentation Tom Zanussi
2018-10-11 21:02 ` Tom Zanussi [this message]
2018-10-23 15:03   ` [PATCH v6 10/15] tracing: Add hist trigger snapshot() action test case Masami Hiramatsu
2018-10-23 21:32     ` Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 11/15] tracing: Add hist trigger onchange() handler Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 12/15] tracing: Add hist trigger onchange() handler Documentation Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 13/15] tracing: Add hist trigger onchange() handler test case Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 14/15] tracing: Add alternative synthetic event trace action syntax Tom Zanussi
2018-10-11 21:02 ` [PATCH v6 15/15] tracing: Add alternative synthetic event trace action test case Tom Zanussi

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=75db4ded21471580e5ad8d57c74fd9c8923cd90a.1539288364.git.tom.zanussi@linux.intel.com \
    --to=zanussi@kernel.org \
    --cc=bigeasy@linutronix.de \
    --cc=joel@joelfernandes.org \
    --cc=julia@ni.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-rt-users@vger.kernel.org \
    --cc=mathieu.desnoyers@efficios.com \
    --cc=mhiramat@kernel.org \
    --cc=namhyung@kernel.org \
    --cc=rostedt@goodmis.org \
    --cc=tglx@linutronix.de \
    --cc=vedang.patel@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).